var fs = require("fs"), path = require("path");
var childProcess = require('child_process');
var reportGenerator = require("../reporting/reportGenerator.js");
var glossaryGenerator = require("../reporting/glossaryGenerator.js");

exports.runTests = function(options) {
	var command = options.cucumberBin +" "+ options.features +" -o \""+ options.output +"\" ";
	childProcess.exec(command, options.finishedCallback).on('exit', options.exitedCallback);
};

exports.generateReport = function(options, callback) {
	reportGenerator.generate({
		features : options.features, 
		input : options.input,
		output : options.output,
		templates : options.templates
	}, function(err, result) {
		if (err) { callback(err); } else {
			callback(null, result);
		}
	});
};
	
exports.getTestHistory = function(options, callback) {
	fs.readdir(options.output, function(err, files) {
		if (err) { callback(err); } else {
			files.sort(function(a, b) {
				var aTime = fs.statSync(path.join(options.output, a)).mtime.getTime();
				var bTime = fs.statSync(path.join(options.output, b)).mtime.getTime();
				return bTime - aTime;
			});
			callback(null, files);
		}
	});
};
	
exports.generateGlossary = function(options, callback) {
	glossaryGenerator.generate({
		features : options.features, 
		templates : options.templates
	}, function(err, result) {
		if (err) { callback(err); } else {
			callback(null, { 
				glossary : result.glossary,
				glossaryJson : result.glossaryJson
			});
		}
	});
};