var fs = require("fs");
var path = require("path");
var handlebars = require("handlebars");

fs.readdirSync(__dirname).forEach(function(filename) {
	if (path.extname(filename) === ".htm") {
		var name = path.basename(filename, ".htm");
		exports[name] = getTemplateFunction(name, __dirname + "/" + filename);
	}
});

function getTemplateFunction(name, filename) {
	return function() {
		var handlebarsInstance = arguments.length > 1 ? arguments[0] : null;
		var callback = arguments.length > 1 ? arguments[1] : arguments[0];
		fs.readFile(filename, function(err, content) {
			if (err) {callback(err);} else {
				var template = handlebars.compile(content.toString())
				if (handlebarsInstance) {
					handlebarsInstance.registerPartial(name, template);
				}
				callback(null, template);
			}
		});
	};
}